// -*- C++ -*-

%module tiger_misc

%include "std_string.i"

%{
#include <sstream>

#include <misc/path.hh>
#include <misc/file-library.hh>

#include <misc/error.hh>
// The need for this using directive seems to be a SWIG bug.  It is
// needed by the _wrap_error___lshift____SWIG_5 in the C++ wrapper
// generated by swig (tiger_bind-wrap.cc).
using misc::error;
%}

%include "misc/path.hh"
%include "misc/file-library.hh"

// Save some warnings from SWIG.
%ignore misc::error::operator=;
%ignore misc::error::operator bool;

// SWIG has trouble wrapping some of misc::error's operator<<'s; ignore them.
%ignore misc::error::operator<<;

%include "misc/error.hh"

// Wrap misc::error::operator<<.
%extend misc::error
{
  std::string
  __str__() const
  {
    std::ostringstream o;
    o << *$self;
    return o.str();
  }

}
